
QGIS Application - Bug report #1900

Qgis crashes after closing a GRASS mapset and removing a GRASS layer from the legend

2009-08-26 11:54 AM - Giovanni Manghi

Status: Closed

Priority: Low

Assignee: Lorenzo Masini

Category: GRASS

Affected QGIS version: Regression?: No

Operating System: All Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed

Crashes QGIS or corrupts data: Copied to github as #: 11960

Description

I can see the following behaviour with some data (the qgis sample dataset for example). I'm using qgis dev version (1.3) installed via

osgeo4w.

To replicate do the following:

*) open the qgis sample (GRASS) dataset

*) add a vector layer

*) close the GRASS mapset (without removing the GRASS vector layer)

*) close qgis (file -> exit)

it is first thrown a warning "variable LOCATION_NAME not set" that appears also under linux, but then under windows the program

crashes. See attached image.

Not really sure to what component assign this ticket.

Associated revisions

Revision 0b697b8c - 2009-09-05 02:00 PM - Jürgen Fischer

apply #1878 (fixes #1900)

git-svn-id: http://svn.osgeo.org/qgis/trunk/qgis@11560 c8812cc2-4d05-0410-92ff-de0c093fc19c

Revision 43408110 - 2009-09-05 02:00 PM - Jürgen Fischer

apply #1878 (fixes #1900)

git-svn-id: http://svn.osgeo.org/qgis/trunk@11560 c8812cc2-4d05-0410-92ff-de0c093fc19c

History

#1 - 2009-08-26 12:42 PM - Jürgen Fischer

not reproducable here using the spearfish dataset.
#2 - 2009-08-26 01:29 PM - Giovanni Manghi

Replying to [comment:1 jef]:

not reproducable here using the spearfish dataset.

Hi,

yes, it doesn't happen with all GRASS mapsets, but i found a few ones that lead qgis to this behavior. Try for example the qgis sample dataset, where you

can find a GRASS mapset.

#3 - 2009-08-26 04:21 PM - Jürgen Fischer

Replying to [comment:2 lutra]:

Replying to [comment:1 jef]:

not reproducable here using the spearfish dataset.

Hi,

yes, it doesn't happen with all GRASS mapsets, but i found a few ones that lead qgis to this behavior. Try for example the qgis sample dataset,

where you can find a GRASS mapset.

The patch in #1878 should fix this - please test.

#4 - 2009-08-27 06:54 AM - Giovanni Manghi

Hi,

if I apply the patch I get the following error while compiling.

By the way I cannot compile under windows, so it would be hard in any case to say if the crash is gone or not.

In file included from /home/gio/Desktop/qgis_unstable/src/providers/grass/qgsgrassprovider.cpp:19:

/home/gio/Desktop/qgis_unstable/src/providers/grass/qgsgrass.h: In constructor ‘QgsGrass::Exception::Exception(const char*)’:

/home/gio/Desktop/qgis_unstable/src/providers/grass/qgsgrass.h:37: error: no matching function for call to ‘std::exception::exception(const

char*&)’

/usr/include/c++/4.3/exception:59: note: candidates are: std::exception::exception()

/usr/include/c++/4.3/exception:57: note:                 std::exception::exception(const std::exception&)

maker2: *** [src/providers/grass/CMakeFiles/qgisgrass.dir/qgsgrassprovider.o] Error 1

maker1: *** [src/providers/grass/CMakeFiles/qgisgrass.dir/all] Error 2

make: *** [all] Error 2

#5 - 2009-08-27 09:03 AM - Jürgen Fischer
Replying to [comment:4 lutra]:

if I apply the patch I get the following error while compiling.

fixed - patch replaced.

#6 - 2009-08-27 01:33 PM - Giovanni Manghi

Replying to [comment:5 jef]:

fixed - patch replaced.

Hi Jurgen,

the patch under linux works, the warning message is gone. If the warning message is the source for the crash under windows, then the problem should be

fixed.

Thanks.

#7 - 2009-08-27 01:35 PM - Giovanni Manghi

Applies the same patch of #1878

#8 - 2009-09-05 05:02 AM - Jürgen Fischer

- Resolution set to fixed

- Status changed from Open to Closed

fixed in commit:43408110 (SVN r11561)

#9 - 2009-09-29 10:24 AM - Giovanni Manghi

- Status changed from Closed to Feedback

- Resolution deleted (fixed)

I have to reopen this ticket because I'm seeing this behaviour again (under Ubuntu 9.04, both qgis 1.3 from repo and 1.4 trunk).

Open a GRASS mapset, add a layer, close the mapset, remove the layer from legend -> qgis crashes

terminate called after throwing an instance of 'QgsGrass::Exception'

  what():  G_getenv(): Variable LOCATION_NAME not set

Aborted

#10 - 2009-11-29 06:18 AM - Giovanni Manghi

- Status changed from Feedback to Open
#11 - 2010-01-07 04:37 AM - Redmine Admin

- Status changed from Open to Closed

- Resolution set to fixed

There are 2 problems here:

1) Bug in GDAL GRASS provider (http://trac.osgeo.org/gdal/ticket/3313), if MAPSET is unset, the next attempt to read GRASS raster data results in

GRASS fatal error. I have written a patch for GDAL (waiting for approval) and temporal fix for QGIS in changeset:12687.

2) Another proble is, how GRASS fatal errors are handled and that is quite interesting. It is possible to set a routine which handles GRASS errors with

G_set_error_routine. The problem is, that both QGIS GRASS plugin and GDAL GRASS driver do it. GDAL sets Grass2CPLErrorHook while GRASS

[[QgsGrass]]::error_routine. When an error happens in GDAL it does not call the Grass2CPLErrorHook but [[QgsGrass]]::error_routine because the routine

was reset in the mean time by QGIS GRASS plugin. [[QgsGrass]]::error_routine throws [[QgsGrass]]::Exception but that is not caught by raster layer

renderer (right, it is expecting error from GDAL) and thus qgis crashes. Isn't it nice!?

I don't know how to solve this at moment, but I close this bug as 1) is resolved and I create a new ticket for 2) : #2347

Files
